; +--------------------------------------+
; |  K-NetLib Constants for BlitzBasic   |
; |        (expects KNL v 3.0.2)         |
; +--------------------------------------+
; |     (C)2005 Krylar's Kreations       |
; | A Division of 1338 Enterprises, Inc. |
; |         All Rights Reserved          |
; +--------------------------------------+
; | Producer: John "Krylar" Logsdon      |
; | Coder...: Derlidio "PJoe" Siqueira   |
; +--------------------------------------+
; | Last Modified: 2005-06-08 (Y-M-D)    |
; +--------------------------------------+

  
; Session options:

  Const KNL_INI_ClientServer = 1 ; User is coding a Client/Server interface.
  Const KNL_INI_Peer2Peer = 2 ; User is coding a Peer To Peer interface.
  Const KNL_INI_Server = 4 ; User wants To host a game.
  Const KNL_INI_Client = 8 ; User will connect To a remote host.
  Const KNL_INI_MigrateHost = 16 ;(Peer only) Migrate host If host falls down.
  Const KNL_INI_Guaranteed = 32 ; Use guaranteed packets.
  Const KNL_INI_Sequential = 64 ; Use sequential delivery.
  Const KNL_INI_LinkTunning = 128 ; Allows DX To tune the network flow.
  Const KNL_INI_CanQueryUser = 256 ; Allows DX To query user For needed info.
  Const KNL_INI_SignPackets = 512 ; Sign all outgoing packets with an 8 byte key.
  Const KNL_INI_UseSHA1 = 1024 ; Sign all outgoing packest using a SHA1 8 byte key.
  Const KNL_INI_LanSession = 2048 ; Open a lagrer window For game sessions running on the same lan.
  
; Service providers:

  Const KNL_Service_IPX = 1
  Const KNL_Service_MODEM = 2
  Const KNL_Service_SERIAL = 4
  Const KNL_Service_TCPIP = 8
  Const KNL_Service_BLUETOOTH = 16
  
; Session Settings Components:

  Const KNL_KEY_NAT_RESOLVER = "natresolver"
  Const KNL_KEY_BAUD = "baud"
  Const KNL_KEY_DEVICE = "device"
  Const KNL_KEY_FLOWCONTROL = "flowcontrol"
  Const KNL_KEY_HOSTNAME = "hostname"
  Const KNL_KEY_PARITY = "parity"
  Const KNL_KEY_PHONENUMBER = "phonenumber"
  Const KNL_KEY_PORT = "port"
  Const KNL_KEY_PROGRAM = "program"
  Const KNL_KEY_PROVIDER = "provider"
  Const KNL_KEY_STOPBITS = "stopbits"
  Const KNL_KEY_NAMEINFO = "nameinfo"
  Const KNL_KEY_PROCESSOR = "processor"
  Const KNL_KEY_TRAVERSALMODE = "traversalmode"
  Const KNL_KEY_APPLICATION_INSTANCE = "applicationinstance"
  Const KNL_KEY_NAT_RESOLVER_USER_STRING = "natresolveruserstring"

; Connect options:

  Const KNL_Process_Async = 0
  Const KNL_Process_Sync = -1

; Message IDs:

  Const KNL_MSG_IndicateConnect = 1
  Const KNL_MSG_ConnectAborted = 2
  Const KNL_MSG_ConnectComplete = 3
  Const KNL_MSG_CreatePlayer = 4
  Const KNL_MSG_DestroyPlayer = 5
  Const KNL_MSG_IndicateSend = 6
  Const KNL_MSG_Receive = 7
  Const KNL_MSG_AsyncOperationComplete = 8
  Const KNL_MSG_SendComplete = 9
  Const KNL_MSG_ServerInfo = 10
  Const KNL_MSG_PlayerInfo = 11
  Const KNL_MSG_CreateGroup = 12
  Const KNL_MSG_EnterGroup = 13
  Const KNL_MSG_LeaveGroup = 14
  Const KNL_MSG_DestroyGroup = 15
  Const KNL_MSG_GroupInfo = 16
  Const KNL_MSG_HostMigrate = 17
  Const KNL_MSG_TerminateSession = 18
  Const KNL_MSG_Handshake = 19
  Const KNL_MSG_ConnectionInfo = 20
  Const KNL_MSG_GameInfo = 21
  Const KNL_MSG_AcceptFile = 22
  Const KNL_MSG_FileAccepted = 23
  Const KNL_MSG_FileRefused = 24
  Const KNL_MSG_FileTransferComplete = 25
  Const KNL_MSG_TimerIgnited = 26
  Const KNL_MSG_TimerStop = 27
  Const KNL_MSG_HostID = 28
  Const KNL_MSG_CAPS = 29
  Const KNL_MSg_SPCAPS = 30
  
; Send Options:

  Const KNL_Priority_Normal = 0
  Const KNL_Priority_Low = 1
  Const KNL_Priority_High = 2
  
  Const KNL_Send_Sync = 1
  Const KNL_Send_Guaranteed = 2
  Const KNL_Send_CompleteOnProcess = 4
  Const KNL_Send_Sequential = 8
  Const KNL_Send_NoComplete = 16
  Const KNL_Send_NoIndicate = 32

; Message Field Types:
  
  Const KNL_Fld_Byte = 2
  Const KNL_Fld_Word = 4
  Const KNL_Fld_Integer = 8
  Const KNL_Fld_Float = 16
  Const KNL_Fld_Double = 32 ; Reserved * Not Implemented *
  Const KNL_Fld_String = 64
  Const KNL_Fld_RawData = 128

  Const KNL_Fld_ByteArray = 3
  Const KNL_Fld_WordArray = 5
  Const KNL_Fld_IntegerArray = 9
  Const KNL_Fld_FloatArray = 17
  Const KNL_Fld_DoubleArray = 33 ; Reserved * Not Implemented *
  Const KNL_Fld_StringArray = 65
  Const KNL_Fld_RawArray = 129

  Const KNL_ArrayMask = 1
  Const KNL_TypeMask = 254
  
; +-------------+
; | User App ID |
; +-------------+

; GUID stands fror Globally Unique IDentifier. Do Not use the key
; presented below For your Game Or App. Instead, generate a brand
; new one using Krylar's Kreations GUID Generator, which is part
; of K-NetLib(MultiPlayer Library) package.

  Const GUID$ = "{3FF6C77D-134C-40E2-9644-F49C425F3548}"
