Type THardWareInfo
	Field SupportModeWidth%[100],SupportModeHeight%[100],SupportModesCount%
End Type

HardWareInfo.THardWareInfo = New THardWareInfo

Function WriteHardWareInfo (HardWareInfo.THardWareInfo)

	Log_file=WriteFile("game.log")

		; write main info
		WriteLine(Log_file, "Hide And Seek - game; date="+CurrentDate$()+", time="+CurrentTime$())
		WriteLine(Log_file,"")

		; write Available GfxModes
		WriteLine(Log_file,"Available GfxModes:")
		type_ct=0
		For i=1 To CountGfxModes3D() 
			isModeAlreadyAdded=False
			For n=1 To 100
				If HardWareInfo\SupportModeWidth[n]=GfxModeWidth(i) And HardWareInfo\SupportModeHeight[n]=GfxModeHeight(i) Then	isModeAlreadyAdded=True			
			Next
			If isModeAlreadyAdded=False
				type_ct=type_ct+1
				HardWareInfo\SupportModeWidth[type_ct]=GfxModeWidth(i)
				HardWareInfo\SupportModeHeight[type_ct]=GfxModeHeight(i)
			EndIf
			WriteLine(Log_file,"Mode "+i+": ("+GfxModeWidth(i)+"x"+GfxModeHeight(i)+"x"+GfxModeDepth(i)+")")
		Next
		HardWareInfo\SupportModesCount=type_ct

		; write GfxDrivers
		WriteLine(Log_file,"")
		For a = 1 To CountGfxDrivers () 
			If GfxDriver3D (a) 
				WriteLine(Log_file,GfxDriverName (a)+ " is 3D-capable")  
			Else 
				WriteLine(Log_file,GfxDriverName (a)+ " is NOT 3D-capable")  
			EndIf 
		Next

		; write is windowed-mode supporting
		WriteLine(Log_file,"")
		If Windowed3D ()
			WriteLine(Log_file,"Windowed mode is available")
		Else 
			WriteLine(Log_file,"Windowed mode is not available - only fullscreen")
		EndIf

		; write Blitz-operations supporting
;		WriteLine(Log_file," ")
;		caps=GfxDriverCaps3D()
;		Select caps 
;			Case 100 msg$="Your graphics card does not support cubic environment mapping." 
;			Case 110 msg$="Your graphics card does support cubic environment mapping." 
;		End Select
;		WriteLine(Log_file,msg$)


		; write about video memory
		WriteLine(Log_file,"")
		WriteLine(Log_file,"Total video memory: "+TotalVidMem())
		WriteLine(Log_file,"Available video memory: "+AvailVidMem())


	CloseFile(Log_file)

End Function