; ---------------------< INCLUDING FILES >-----------------------------------------
Include "scripts\logHandler.bb"
Include "scripts\BBGui_include.bb"
Include "scripts\gnet_inc.bb"

SeedRnd MilliSecs()


game_name$="Nature"
	server_name$="HAS."
	server_name$=server_name$+game_name$+","
	name$=Rand(0,10000)
	n = CountHostIPs("") 
	ip = HostIP(1) 
	ipaddress$ = DottedIP$(ip) 
	server_name$=server_name$+ipaddress$



;#Region ================================== GLOBAL before all ==================================

	Global home$=""

	Global Real_fps,Real_fps_time,Real_fps_count

	Global key_down_w,key_down_s,key_down_a,key_down_d
	Global key_down_space
	Global mbleft_down,mbleft_click,mbright_down,mbright_click	

;#End Region 




; ---------------------< CHECK HARDWARE >----------------------------------------

WriteHardWareInfo(HardWareInfo.THardWareInfo)


If GfxMode3DExists (800,600,32)
	Graphics3D 800,600,32,2
	SetBuffer BackBuffer()
	AppTitle "HideAndSeek"
	;HidePointer()
Else
	RuntimeError "Screen-mode 800,600,32,2 unsupported! game will closing - please restart game." 
EndIf

;#Region ================================== GLOBAL before menu ==================================

	Global font=LoadFont("Times new roman",18,0,0,0)

;#End Region 


;Dim ServersListArray$(100)

Type TServersList
	Field full_game_name$[100],game_name$[100],game_ip$[100]
End Type

	HAS_servers_list.TServersList = New TServersList

Type TMenu
	Field imStart,Start_ActiveFrame
	Field imExit,Exit_ActiveFrame
	Field imLoading
	Field imCursor
End Type

menu.TMenu = New TMenu

Dim design.guidesign(3)
design(0)=guidesignskin(home$+"datafiles\menu\designs\gui_large.bmp",255,255,255,255,255,255)
design(1)=guidesignskin(home$+"datafiles\menu\designs\gui_medium.bmp",255,255,255,255,255,255)
design(2)=guidesignskin(home$+"datafiles\menu\designs\gui_small.bmp",255,255,255,255,255,255)




ServersListWindow.window = window(100,100,420,420,design(0),font,1,"The list of accessible servers:",0,0)
ServersRealList.gadget=gadgettextselection(ServersListWindow,100,100,200,200 , "" , 0 , design(0), font , "" , -1  )
ButtonCreateGame.gadget=gadgetbutton(ServersListWindow,80,20,240,50,"Create game",0,design(0),font)
ButtonJoinGame.gadget=gadgetbutton(ServersListWindow,120,310,160,30,"Join to server",0,design(0),font)
ButtonRefresh.gadget=gadgetbutton(ServersListWindow,130,360,140,30,"Refresh",0,design(0),font)

ButtonExit.gadget=gadgetbutton(ServersListWindow,330,370,80,20,"Exit",0,design(0),font)


Repeat
Cls




If gadgetreleased(ButtonCreateGame) ;create



	GNET_Ping()
	If Not GNET_AddServer( server_name$ )
		RuntimeError "Failed to add server"
	EndIf
	HostNetGame(server_name$)
	isWeHost=True
	Goto label_StartGame
	
ElseIf gadgetreleased(ButtonJoinGame) ;connect
	name$=Rand(0,10000)

	ServersList_index%=gadgetgetvalue(ServersRealList)

	If ServersList_index%>-1
		If ServersList_index%>-1
			joinResults=JoinNetGame(HAS_servers_list\full_game_name$[ServersList_index%],HAS_servers_list\game_ip$[ServersList_index%])
			If joinResults=1
				isWeHost=False
				Goto label_StartGame
			Else
				RuntimeError "Failed to connect!"
			EndIf
		EndIf
	Else
		RuntimeError "Failed to connect!"
	EndIf

	Goto label_StartGame

ElseIf gadgetreleased(ButtonRefresh) ;refresh

	If Not GNET_ListServers()
		RuntimeError "Failed to list servers"
	EndIf

	check_str$=""
	i=-1
	For t.GNET_Server=Each GNET_Server
		i=i+1

		ch_str1$=t\game$
		ch_game_id$=Left$(ch_str1,3)

		If ch_game_id$="HAS"
		
			komma_location%=Instr(ch_str1,",",1)
			
			ch_game_name$=Mid$(ch_str1,5,komma_location-5)
			ch_game_ip$=Right$(ch_str1,(Len(ch_str1$)-komma_location))

			HAS_servers_list\full_game_name$[i]=ch_str1$
			HAS_servers_list\game_name$[i]=ch_game_name$
			HAS_servers_list\game_ip$[i]=ch_game_ip$
			
			check_str$=check_str$+HAS_servers_list\game_name$[i]+"|"
	
		EndIf
		
	Next
	
	gadgetdelete(ServersRealList)
	ServersRealList.gadget=gadgettextselection(ServersListWindow,100,100,200,200 , "" , 0 , design(0), font , check_str$ , -1  )

EndIf
	
	

	
	windowinteractall()
	gadgetinteractall()
	windowdrawall()

UpdateWorld
RenderWorld
Flip	
Until KeyDown(1)
End



.label_StartGame



Cls
Flip






my_game$="My_Game"




netgame=1

If netgame Then myid=CreateNetPlayer(name) Else myid=Rand(0,1000)



Graphics3D 800,600,32,2
SetBuffer BackBuffer()
HidePointer()

;#Region ================================== GLOBAL before game ==================================

	Global CenterX=GraphicsWidth()/2
	Global CenterY=GraphicsHeight()/2
	
	Global fntHUD=LoadFont("Verdana",18,False,False,False)	

	
;#End Region 

; --------------------------< INIT CONSTANTS >---------------------------------

	Const Player_col_type%=1
	Const World_col_type%=2


	
;-------------------------------------------------------------------------------




; ----------------------------< INIT TYPES >-----------------------------------

	Type gravity 
		Field entity 
		Field dy#
		Field entity_grav#
	End Type

	Type TPlayer
		Field name$,id
		Field cam 
		Field pivot
		Field mesh
		Field grav.gravity 
		Field dx#,dy#,dz#
		Field life
		Field sens#,jump_height%,velocity#
	End Type	
	
;-------------------------------------------------------------------------------


; ----------------------------< INIT PLAYER >-----------------------------------

	player.TPlayer=New TPlayer
	
	player\pivot=CreatePivot()
	player\cam=CreateCamera(player\pivot)
	CameraRange player\cam,1,1000000
	MoveEntity player\cam,0,8,0
	
	player\life=50
	
	player\sens#=0.1
	player\jump_height%=15
	player\velocity#=1.4
	player\mesh=CreateSphere(8,player\pivot)
	ScaleEntity player\mesh,4,4,4
	
	PositionEntity player\pivot,0,0,0
		
	EntityRadius player\pivot,5,11
	EntityType player\pivot,Player_col_type

	player\grav=AddGravity(player\pivot)
	
	player\id=myid
	player\name=name

; -------------------------------------------------------------------------------



sky=CreateSky("res\sky\")
ScaleEntity sky,10000,10000,10000
EntityOrder sky,10


world=LoadMesh("res\world\world.b3d")
MoveEntity world,0,-100,0
EntityType world,World_Col_Type

light0=CreateLight(2,player\pivot)
MoveEntity light0,0,10,0
LightRange(light0,100)



; ----------------------------< Collisions >--------------------------------------
	Collisions Player_col_type,World_col_type,2,3

; -------------------------------------------------------------------------------

MoveMouse CenterX,CenterY

bIsPaused=False

Repeat


	If KeyHit(25)
		If bIsPaused=True Then bIsPaused=False Else bIsPaused=True	
	EndIf

	CheckKeys()
		
	
	If bIsPaused=False
		For player.TPlayer = Each TPlayer
			If player\name=name
				MovePlayer(player.TPlayer)
			EndIf
		Next		

		ActiveGravity()

	EndIf	



		















	
	
	UpdateWorld
	RenderWorld
	
	Text 0,0,"My id = "+name$

	If netgame

	For player.TPlayer = Each TPlayer
		If player\name=name
			SendNetMsg 1,EntityX#(player\pivot),myid,0,0
			SendNetMsg 2,EntityY#(player\pivot),myid,0,0
			SendNetMsg 3,EntityZ#(player\pivot),myid,0,0
		EndIf
	Next
	

		While RecvNetMsg()
	
			nt=NetMsgType()
			
			If nt=1
				x#=Float(NetMsgData()) 
			
			ElseIf nt=2
				y#=Float(NetMsgData()) 
				
			ElseIf nt=3
				z#=Float(NetMsgData())

			ElseIf nt=100
			
				player.TPlayer=New TPlayer
				
				player\pivot=CreatePivot()
				;player\cam=CreateCamera(player\pivot)
				;CameraRange player\cam,1,1000000
				;MoveEntity player\cam,0,8,0
				
				player\life=50
				
				player\sens#=0.1
				player\jump_height%=15
				player\velocity#=1.4
				player\mesh=CreateSphere(8,player\pivot)
				
				ScaleEntity player\mesh,4,4,4
				
				PositionEntity player\pivot,0,0,0
					
				EntityRadius player\pivot,5,11
				EntityType player\pivot,Player_col_type
			
				player\grav=AddGravity(player\pivot)
				
				player\id=NetMsgFrom()
				player\name=NetPlayerName(player\id)			
			
		
			EndIf

			For player.TPlayer = Each TPlayer
		
				If player\id=NetMsgFrom()
					PositionEntity player\pivot,x#,y#,z# 
				EndIf
				
			Next

		Wend

	EndIf


	DrawGUI()

Flip
Until KeyDown(1)

.label_end_game

If isWeHost=True
	If Not GNET_RemoveServer( server_name$ )
		RuntimeError "Failed to remove server"
	EndIf
EndIf


Function ListServers()
	If Not GNET_ListServers()
		RuntimeError "Failed to list servers"
	EndIf

	Print LSet$("Game",16)+LSet$("Server",32)+LSet$("IP",16)
	Print String$("-",64)
	For t.GNET_Server=Each GNET_Server
		Print LSet$(t\game$,32)+LSet$(t\server$,32)+LSet$(t\ip$,16)
	Next
	Print ""
End Function

Function CheckKeys()
	
	If KeyDown(17)	Then key_down_w=True		Else key_down_w=False
	If KeyDown(31)	Then key_down_s=True		Else key_down_s=False
	If KeyDown(30)	Then key_down_a=True		Else key_down_a=False
	If KeyDown(32)	Then key_down_d=True		Else key_down_d=False
	If KeyDown(57)	Then key_down_space=True	Else key_down_space=False
	If MouseDown(1)	Then mbleft_down=True 		Else mbleft_down=False
	If MouseHit(17)	Then mbleft_click=True 		Else mbleft_click=False
	If MouseDown(2)	Then mbright_down=True 		Else mbright_down=False
	If MouseHit(2)	Then mbright_click=True		Else mbright_click=False

End Function

Function AddGravity.gravity(for_entity) 

	c.gravity=New gravity 
	c\entity_grav#=0.1
	c\entity=For_entity 
	
	Return c 

End Function 

Function ActiveGravity() 

	For i.gravity=Each gravity 
		If Not EntityCollided( i\entity,World_col_type) 
			i\dy=i\dy-i\entity_grav#
			TranslateEntity i\entity,0,i\dy,0 
		Else 
			For n=1 To CountCollisions ( i\entity)
				m#=CollisionNY# ( i\entity,n)
	
				If m#>0.8 And m#<1.1
					i\dy#=0
				Else
					i\dy=i\dy-i\entity_grav#
					
				EndIf

				If m#<-0.8 And m#>-1.2 Then i\dy=i\dy-i\entity_grav#

				TranslateEntity i\entity,0,i\dy#,0

			Next
			
		EndIf 
	Next 
	
End Function 

Function MovePlayer(player.TPlayer)

	MoveEntity player\pivot,(KeyDown(32)-KeyDown(30))*1.4,0,(KeyDown(17)-KeyDown(31))*1.4
	
	If KeyDown(57)=True And player\grav\dy=0
		player\grav\dy#=player\grav\entity_grav#*player\jump_height%
		TranslateEntity player\pivot,0,0.3,0 
	EndIf

	dx#=(CenterX-MouseX())*player\sens#
	dy#=(CenterY-MouseY())*player\sens#
	Ty=EntityPitch#(player\cam)
	If Ty-dy>90 Then dy#=Ty-90
	If Ty-dy<-90 Then dy#=Ty+90
	TurnEntity player\pivot,0,dx,0
	TurnEntity player\cam,-dy,0,0

	MoveMouse CenterX,CenterY

End Function

Function CreateSky( file_name$ )

	sky_mesh=CreateMesh()
	;front face
	sky_brush=LoadBrush( file_name$+"sky_FR.jpg",49 )
	sky_surface=CreateSurface( sky_mesh,sky_brush)
	AddVertex sky_surface,-1,+1,-1,0,0:AddVertex sky_surface,+1,+1,-1,1,0
	AddVertex sky_surface,+1,-1,-1,1,1:AddVertex sky_surface,-1,-1,-1,0,1
	AddTriangle sky_surface,0,1,2:AddTriangle sky_surface,0,2,3
	FreeBrush sky_brush
	;right face
	sky_brush=LoadBrush( file_name$+"sky_LF.jpg",49 )
	sky_surface=CreateSurface( sky_mesh,sky_brush )
	AddVertex sky_surface,+1,+1,-1,0,0:AddVertex sky_surface,+1,+1,+1,1,0
	AddVertex sky_surface,+1,-1,+1,1,1:AddVertex sky_surface,+1,-1,-1,0,1
	AddTriangle sky_surface,0,1,2:AddTriangle sky_surface,0,2,3
	FreeBrush sky_brush
	;back face
	sky_brush=LoadBrush( file_name$+"sky_BK.jpg",49 )
	sky_surface=CreateSurface( sky_mesh,sky_brush )
	AddVertex sky_surface,+1,+1,+1,0,0:AddVertex sky_surface,-1,+1,+1,1,0
	AddVertex sky_surface,-1,-1,+1,1,1:AddVertex sky_surface,+1,-1,+1,0,1
	AddTriangle sky_surface,0,1,2:AddTriangle sky_surface,0,2,3
	FreeBrush sky_brush
	;left face
	sky_brush=LoadBrush( file_name$+"sky_RT.jpg",49 )
	sky_surface=CreateSurface( sky_mesh,sky_brush )
	AddVertex sky_surface,-1,+1,+1,0,0:AddVertex sky_surface,-1,+1,-1,1,0
	AddVertex sky_surface,-1,-1,-1,1,1:AddVertex sky_surface,-1,-1,+1,0,1
	AddTriangle sky_surface,0,1,2:AddTriangle sky_surface,0,2,3
	FreeBrush sky_brush
	;top face
	sky_brush=LoadBrush( file_name$+"sky_UP.jpg",49 )
	sky_surface=CreateSurface( sky_mesh,sky_brush)
	AddVertex sky_surface,-1,+1,+1,0,1:AddVertex sky_surface,+1,+1,+1,0,0
	AddVertex sky_surface,+1,+1,-1,1,0:AddVertex sky_surface,-1,+1,-1,1,1
	AddTriangle sky_surface,0,1,2:AddTriangle sky_surface,0,2,3
	FreeBrush sky_brush
	;bottom face	
	sky_brush=LoadBrush( file_name$+"sky_DN.jpg",49 )
	sky_surface=CreateSurface( sky_mesh,sky_brush)
	AddVertex sky_surface,-1,-1,-1,1,0:AddVertex sky_surface,+1,-1,-1,1,1
	AddVertex sky_surface,+1,-1,+1,0,1:AddVertex sky_surface,-1,-1,+1,0,0
	AddTriangle sky_surface,0,1,2:AddTriangle sky_surface,0,2,3
	FreeBrush sky_brush
	FlipMesh sky_mesh
	EntityFX sky_mesh,1
	
	Return sky_mesh
	
End Function

Function DrawGUI()

;#Region - FPS count -

	Real_fps_count=Real_fps_count+1
	If Real_fps_time=0 Then Real_fps_time=MilliSecs()
	If Real_fps_time+1000 < MilliSecs() Then
	    Real_fps=Real_fps_count
	    Real_fps_count=0
	    Real_fps_time=MilliSecs()
	EndIf
	
;#End Region
	
	SetFont fntHUD
	Color 206,240,237
	
	Text 10,20,"FPS: "+Real_fps
	Text 10,40,"TRIS: "+TrisRendered()
	Text 10,60,"VideoMem: "+AvailVidMem()/1000000+"Mb/"+TotalVidMem()/1000000+"Mb"	
	
End Function

End